Option Strict On

Public Class frmDragAndDrop
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
  Friend WithEvents lstBox1 As System.Windows.Forms.ListBox
  Friend WithEvents lstBox2 As System.Windows.Forms.ListBox
  Friend WithEvents lblInfo As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
Me.lstBox1 = New System.Windows.Forms.ListBox()
Me.lstBox2 = New System.Windows.Forms.ListBox()
Me.lblInfo = New System.Windows.Forms.Label()
Me.SuspendLayout()
'
'lstBox1
'
Me.lstBox1.Location = New System.Drawing.Point(16, 112)
Me.lstBox1.Name = "lstBox1"
Me.lstBox1.Size = New System.Drawing.Size(176, 108)
Me.lstBox1.TabIndex = 0
'
'lstBox2
'
Me.lstBox2.Location = New System.Drawing.Point(216, 80)
Me.lstBox2.Name = "lstBox2"
Me.lstBox2.Size = New System.Drawing.Size(176, 108)
Me.lstBox2.TabIndex = 1
'
'lblInfo
'
Me.lblInfo.Font = New System.Drawing.Font("Arial", 9.0!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
Me.lblInfo.Location = New System.Drawing.Point(8, 8)
Me.lblInfo.Name = "lblInfo"
Me.lblInfo.Size = New System.Drawing.Size(392, 32)
Me.lblInfo.TabIndex = 2
Me.lblInfo.Text = "Mit der rechten Maustaste das Control verschieben. Mit der linken kann man Elemen" & _
"te in die andere Listbox verschieben"
Me.lblInfo.TextAlign = System.Drawing.ContentAlignment.TopCenter
'
'frmDragAndDrop
'
Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
Me.ClientSize = New System.Drawing.Size(408, 262)
Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblInfo, Me.lstBox2, Me.lstBox1})
Me.Name = "frmDragAndDrop"
Me.Text = "Drag 'n Drop"
Me.ResumeLayout(False)

    End Sub

#End Region

    ' Diese Struktur lst das Problem, dass man ein Element in die selbe 
    ' Listbox verschiebt, in dem es eine Owner-Eigenschaft hinzufgt, die vor '
    ' dem Hinzufgen berprft wird. Dank der ToString-Funktion wird in der '
    ' Listbox der von uns angegebene Text ausgegeben
    Private Class ListBoxItem
        Public text As String
        Public owner As ListBox

        Public Overrides Function ToString() As String
            Return "Element: " & text
        End Function

        Public Sub New(ByVal name As String, ByVal owner As ListBox)
            Me.text = name
            Me.owner = owner
        End Sub
    End Class

    ' Wird eine Listbox verschoben?
    Private ControlMove As Boolean

    Private Sub frmDragAndDrop_Load(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MyBase.Load

        ' Drag & Drop sowohl fr die Listboxen (d.h. die Items) 
        ' als auch die Form (die Controls) aktivieren
        lstBox1.AllowDrop = True
        lstBox2.AllowDrop = True
        Me.AllowDrop = True

        ' Ein paar Testeintrge in die Listbox hinzufgen
        Dim i As Integer
        For i = 0 To 5
            lstBox1.Items.Add(New ListBoxItem(i.ToString, lstBox1))
            lstBox2.Items.Add(New ListBoxItem(i.ToString, lstBox2))
        Next
    End Sub

    Private Sub Listbox_Move(ByVal sender As Object, _
        ByVal e As DragEventArgs) _
        Handles MyBase.DragOver, lstBox1.DragOver, lstBox2.DragOver

        ' Wenn ein Drag&Drop-Vorgang fr eine Listbox gestartet ist ...
        If ControlMove Then
            Dim ctrl As Control = _
                DirectCast(e.Data.GetData(GetType(ListBox)), ListBox)

            ' ... das Control immer an die Position verschieben
            ctrl.Location = Me.PointToClient(New Point(e.X, e.Y))
        End If
    End Sub

    Private Sub ListBox_MouseDown(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.MouseEventArgs) _
        Handles lstBox1.MouseDown, lstBox2.MouseDown

        ' Dadurch, dass wir mit dem Ereignis gleich zwei Controls abfangen, 
        ' knnen wir uns Wiederholungen sparen
        Dim box As ListBox = DirectCast(sender, ListBox)

        If e.Button = MouseButtons.Right Then
            ' Drag&Drop fr die ListBox starten, wenn die rechte Maustaste 
            '  gedrckt ist
            ControlMove = True
            Me.DoDragDrop(box, DragDropEffects.Move)
        ElseIf box.SelectedIndex <> -1 Then
            ' Drag&Drop fr ein ListBoxItem starten, sofern denn eins markiert 
            ' ist
            box.DoDragDrop(box.Items(box.SelectedIndex), _
            DragDropEffects.Move)
        End If
    End Sub

    Private Sub ListBox_DragEnter(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.DragEventArgs) _
        Handles lstBox1.DragEnter, lstBox2.DragEnter

        If e.Data.GetDataPresent(GetType(ListBoxItem)) Then
            ' Wenn ein ListBoxItem vorhanden ist, dann den 
            ' Drop-Vorgang erlauben. Die Kontrolle auf ein 
            ' ListBoxItem ist notwendig, weil sonst "alles" 
            ' in die ListBox verschoben werden knnte, 
            ' was schlielich im Drop-Ereignis einen Fehler 
            ' zur Folge htte.
            e.Effect = DragDropEffects.Move
        End If
    End Sub

    Private Sub ListB_DragDrop(ByVal sender As Object, _
        ByVal e As DragEventArgs) _
        Handles MyBase.DragDrop, lstBox1.DragDrop, lstBox2.DragDrop

        ' Dies ist das Drop-Ereignis fr die Controls. 
        ' Wenn also das Control "gedropt" wurde,
        ' ControlMove auf False setzen
        If ControlMove = True Then ControlMove = False
    End Sub

    Private Sub ListBox_DragDrop(ByVal sender As Object, _
        ByVal e As System.Windows.Forms.DragEventArgs) _
        Handles lstBox2.DragDrop, lstBox1.DragDrop

        Dim box As ListBox = DirectCast(sender, ListBox)
        Dim item As ListBoxItem

        ' Nochmal auf den richtigen Datentyp prfen 
        If e.Data.GetDataPresent(GetType(ListBoxItem)) Then
            item = DirectCast(e.Data.GetData(GetType(ListBoxItem)), ListBoxItem)
            If Not item.owner Is sender Then

                ' Das Element in die Listbox hinzufgen ...
                box.Items.Add(item)

                ' und in der anderen Lschen
                If box Is lstBox1 Then
                    lstBox2.Items.Remove(item)
                Else
                    lstBox1.Items.Remove(item)
                End If
                item.owner = box
            End If
        End If
    End Sub
End Class
